//$Id: Unwrap.java,v 1.5 2007/06/26 00:09:03 gavin Exp $
package org.jboss.seam.annotations;

import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * Specifies that the object returned by the annotated
 * getter method is to be injected instead of the
 * component itself. Supports use of the Seam "manager 
 * component" pattern.
 * 
 * @author Gavin King
 */
@Target(METHOD)
@Retention(RUNTIME)
@Documented
@Inherited
public @interface Unwrap {}
